! f90 BYU SIR file format include file
!
! This include file defines key platform-dependent parameters
!
! Edit based on platform
!
!	include file to define platform dependent parameters for
!	reading/writing BYU SIR file formats
!
        INTEGER :: ISIRRECLENGTH = 512 ! bytes/record in file open statement
				!  (typically 512 or 128)
				!  SIR header record length is 512 bytes
				!  and SIR file is a multiple of 512 bytes long
				!  Set this variable to value used to specify a
				!  512 byte record in file open statement RECL
				!  HPUX, Sun, linux use RECL=512 (bytes/record)
				!  SGI, VAX use RECL=128 (4 byte words/record)
!
	LOGICAL :: BSWAP = .FALSE. ! byte swap if BSWAP is true
				!  SIR files are stored big-endian (the
				!  standard byte order on typical unix
				!  platforms, e.g. HP, SGI, SUN
				!  set BSWAP to .TRUE. for little-endian 
				!  (least-significant byte first) machines
				!  such as VAX and intel machines
				!  set BSWAP to .FALSE. for big-endian 
				!  (most-significant byte first) machines
				!  such as HP, SUN, Motorolla, etc.
!
	INTEGER :: VMS = .FALSE. ! if .TRUE., VMS-style file read/write is used
				!  otherwise, unix-style file read/write used
				!  (note: some of the VMS open options are
				!  commented out to make non-VMS compilers
				!  happy)





